# -*- sh -*-***************
#  OF Tree for MacOS X
# *************************

#
# **************** NODE device-tree ***************
#
{
    (name device-tree )
    (type bootrom )
    (mol_phandle 0xFF83A248 )
    (property pci-OF-bus-map     <word>
        0x000000ff 0xffffffff 0xffffffff 0xffffffff 
        0xffffffff 0xffffffff 0xffffffff 0xffffffff 
        0xffffffff 0xffffffff 0xffffffff 0xffffffff 
        0xffffffff 0xffffffff 0xffffffff 0xffffffff 
        0xffffffff 0xffffffff 0xffffffff 0xffffffff 
        0xffffffff 0xffffffff 0xffffffff 0xffffffff 
        0xffffffff 0xffffffff 0xffffffff 0xffffffff 
        0xffffffff 0xffffffff 0xffffffff 0xffffffff 
        0xffffffff 0xffffffff 0xffffffff 0xffffffff 
        0xffffffff 0xffffffff 0xffffffff 0xffffffff 
        0xffffffff 0xffffffff 0xffffffff 0xffffffff 
        0xffffffff 0xffffffff 0xffffffff 0xffffffff 
        0xffffffff 0xffffffff 0xffffffff 0xffffffff 
        0xffffffff 0xffffffff 0xffffffff 0xffffffff 
        0xffffffff 0xffffffff 0xffffffff 0xffffffff 
        0xffffffff 0xffffffff 0xffffffff 0xffffffff  )
    (property clock-frequency    <word> 	0x03F7EC51 )
    (property #size-cells        <word> 	0x00000001 )
    (property #address-cells     <word> 	0x00000001 )
    (property system-id          <str>  	"0000000000000" )
    (property device_type        <str>  	"bootrom" )
    (property copyright          <str>  	
        "Copyright 1983-1999 Apple Computer, Inc. All Rights Reserved" )
    (property name               <str>  	"device-tree" )
    (property color-code <byte> 
        0xFF 0x06  )
    (property customer-sw-config <str>  	"           " )
    (property serial-number <byte> 
        0x48 0x5A 0x53 0x4D 0x37 0x37 0x31 0x36 0x53 0x2F 0x41 0x00 
        0x00 0x55 0x56 0x30 0x30 0x37 0x34 0x50 0x41 0x00 0x00 0x00 
        0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 
        0x00 0x00 0x00 0x00 0x00 0x00 0x00  )
    (property compatible         <str>  	"AAPL,MOL", "MacRISC", "Power Macintosh" )
    (property model              <str>  	"AAPL,MOL" )

    #
    # **************** NODE cpus ***************
    #
    {
        (name cpus )
        (mol_phandle 0xFF83B2F0 )
        (property #size-cells        <word> 	0x00000000 )
        (property #address-cells     <word> 	0x00000001 )
        (property name               <str>  	"cpus" )
    
	#
	# **************** NODE cpu ***************
	# Placeholder for the imported CPU node

	{
	    (name dummy_cpu )
	    (type cpu )
	    (property type           <str>  	"cpu" )
	    (property name           <str>  	"dummy_cpu" )
	}
    }

    #
    # **************** NODE chosen ***************
    #
    {
        (name chosen )
        (mol_phandle 0xFF83C3A0 )
        (property interrupt-controller <word> 	0x00001234 )
        (property cpu                <word> 	0xFF9DD640 )
        (property bootargs           <str>  	"" )
        (property pmu                <word> 	0xFF9CF280 )
        (property nvram              <word> 	0xFF9CF400 )
        (property mmu                <word> 	0xFF9DD640 )
        (property memory             <word> 	0xFF9DD700 )
        (property stdout             <word> 	0xFF9CE5C0 )
        (property stdin              <word> 	0xFF9CEC00 )
        (property name               <str>  	"chosen" )
    }

    #
    # **************** NODE memory ***************
    #
    {
        (name memory )
        (type memory )
        (mol_phandle 0xFF83C530 )
        (addrs
            (0x00000000 0x00000000 0x04000000 )
            (0x00000000 0x04000000 0x08000000 )
        )
        (property available          <word>
            0x00003000 0x001fd000 0x00220000 0x000e0000 
            0x00400000 0x00c00000 0x01400000 0x0aa00000  )
        (property slot-names <byte> 
            0x00 0x00 0x00 0x03 0x44 0x49 0x4D 0x4D 0x30 0x2F 0x42 0x55 
            0x49 0x4C 0x54 0x2D 0x49 0x4E 0x00 0x44 0x49 0x4D 0x4D 0x31 
            0x2F 0x4A 0x31 0x32 0x00  )
        (property reg                <word>
            0x00000000 0x04000000 0x04000000 0x08000000  )
        (property device_type        <str>  	"memory" )
        (property name               <str>  	"memory" )
    }

    #
    # **************** NODE openprom ***************
    #
    {
        (name openprom )
        (type BootROM )
        (mol_phandle 0xFF83C748 )
        (property boot-syntax        <word> 	0x00000001 )
        (property supports-bootinfo  <word>
             )
        (property relative-addressing <word>
             )
        (property model              <str>  	"OpenFirmware 3" )
        (property device_type        <str>  	"BootROM" )
        (property name               <str>  	"openprom" )
        
        #
        # **************** NODE client-services ***************
        #
        {
            (name client-services )
            (mol_phandle 0xFF83C878 )
            (property name               <str>  	"client-services" )
        }
    }
    #
    # **************** NODE options ***************
    #
    {
        (name options )
        (mol_phandle 0xFF83DDA0 )
        (property boot-args          <word>
             )
        (property aapl,pci           <word>
            0x2f6f6666 0x73637265 0x656e2d64 0x6973706c 0x6179ff01 
            0x67707266 0xff01ff81 0x01070101 0xff8104ff 0x012f4066 
            0x32303030 0x3030302f 0x4031372f 0x40663330 0x30ff0162 
            0x6b6c74ff 0x011f07ff 0x81010aff 0x8181ff81 0x03ff012f 
            0x40663030 0x30303030 0x302f4031 0x30ff0141 0x444d53ff 
            0x01ff8101 0x2a2aff81 0x81ff8101 0x8214ff81 0x01ff0100  )
        (property boot-script        <str>  	"" )
        (property default-router-ip  <str>  	"" )
        (property default-subnet-mask <str>  	"" )
        (property default-gateway-ip <str>  	"" )
        (property default-server-ip  <str>  	"" )
        (property default-client-ip  <str>  	"" )
        (property boot-command       <str>  	"mac-boot" )
        (property oem-logo           <str>  	"" )
        (property oem-banner         <str>  	"" )
        (property mouse-device       <str>  	"mouse" )
        (property output-device-1    <str>  	"scca" )
        (property input-device-1     <str>  	"scca" )
        (property output-device      <str>  	"screen" )
        (property input-device       <str>  	"keyboard" )
        (property diag-file          <str>  	",diags" )
        (property diag-device        <str>  	"enet" )
        (property console-screen     <str>  	"" )
        (property boot-screen        <str>  	"" )
        (property boot-file          <str>  	"" )
        (property boot-device        <str>  	"" )
        (property selftest-#megs     <str>  	"0" )
        (property screen-#rows       <str>  	"40" )
        (property screen-#columns    <str>  	"100" )
        (property pci-probe-mask     <str>  	"-1" )
        (property virt-size          <str>  	"-1" )
        (property virt-base          <str>  	"-1" )
        (property load-base          <str>  	"0x800000" )
        (property real-size          <str>  	"-1" )
        (property real-base          <str>  	"-1" )
        (property default-mac-address? <str>  	"false" )
        (property use-generic?       <str>  	"false" )
        (property use-nvramrc?       <str>  	"false" )
        (property oem-logo?          <str>  	"false" )
        (property oem-banner?        <str>  	"false" )
        (property fcode-debug?       <str>  	"false" )
        (property diag-switch?       <str>  	"false" )
        (property auto-boot?         <str>  	"true" )
        (property real-mode?         <str>  	"false" )
        (property little-endian?     <str>  	"false" )
        (property name               <str>  	"options" )
    }

    #
    # **************** MOL nvram ***************
    #
    {
        (name mol-nvram )
        (type nvram )
        (mol_phandle 0xFF8932C0 )
        (addrs
            (0x00000000 0xFFF04000 0x00004000 )
        )
        (property #bytes             <word> 	0x00002000 )
        (property reg                <word>
            0xfff04000 0x00004000  )
        (property device_type        <str>  	"mol-nvram" )
        (property name               <str>  	"mol-nvram" )
    }

    #
    # **************** NODE osi-pic (mol) ***************
    #
    {
	(name osi-pic )
	(type interrupt-controller )
	(property name			<str>	"osi-pic" )
	(property device_type		<str>	"interrupt-controller" )
	(mol_phandle				0x00001234 )
	(property at-boot			)
	(property interrupt-controller	<word>	)
	(property #interrupt-cells	<word>	0x00000001 )
    }

    #
    # ####################### MOL keyboard ############################
    #
    {
	(name mol-keyboard )
	(type mol-keyboard )
	(property name			<str>	"mol-keyboard" )
	(property device_type		<str>	"mol-keyboard" )
	(property interrupt-parent	<word>	0x00001234 )
	(property interrupts		<word>	0x00000003 )
	(property mol-irq		<word>  0x00000003 )
    }

    #
    # ####################### MOL audio ############################
    #
    {
	(name mol-audio )
	(type sound )
	(property name			<str>	"mol-audio" )
	(property device_type		<str>	"sound" )
	(property interrupt-parent	<word>	0x00001234 )
	(property interrupts		<word>	0x00000001 )
	(property mol-irq		<word>  0x00000001 )
    }


    #
    # ####################### MOL mouse ############################
    #
    {
	(name mol-mouse )
	(type mol-mouse )
	(property name			<str>	"mol-mouse" )
	(property device_type		<str>	"mol-mouse" )
	(property interrupt-parent	<word>	0x00001234 )
	(property interrupts		<word>	0x00000004 )
	(property mol-irq		<word>  0x00000004 )
    }

    #
    # **************** NODE mol-enet ***************
    #
    {
	(name mol-enet )
	(type mol-enet )
	(property device_type		<str>	"mol-enet" )
	(property name			<str>	"mol-enet" )
	(property interrupt-parent	<word>	0x00001234 )
	(property interrupts		<word>	0x00000005 )
	(property mol-irq		<word>	0x00000005 )
    }

    #
    # ####################### MOL blk device ##########################
    #
    {
	(name mol-blk )
	(property name			<str>  	"mol-blk" )
	(property interrupt-parent	<word>	0x00001234 )
	(property interrupts		<word>	0x00000002 )
	(property mol-irq		<word>	0x00000002 )
	#unit_string == channel
	(unit_string 0 )
	#(property channel		<word>	0x00000000 )
	{
	    (name disk )
	    (type disk )
	    (unit_string * )
	    (property name	     <str>	"disk" )
	    (property device_type    <str>	"block" )
	}
    }

    #
    # ####################### NODE mac-io ##########################
    #  NOTE: This dummy node is necessary (the kernel panics otherwise)
    {
       (name mac-io )
       (type mac-io )
       (mol_phandle 0xFF898040 )
       (property assigned-addresses <word>
            0x8200b810 0x00000000 0x80000000 0x00000000 0x00080000  )
       (property model              <str>      "AAPL,Keylargo-DUMMY" )
       (property device_type        <str>      "mac-io" )
       (property name               <str>      "mac-io" )
    }

    #
    # **************** NODE pci ***************
    #
    {
        (name pci )
        (type pci )
        (addrs
            (0x00000000 0x80000000 0x7F000000 )
        )
	# Map 0x08 (device  1) to IRQ 24 (0x18) (unused)
	# Map 0x80 (device 16) to IRQ 23 (0x17) (mol-video)
        (property #interrupt-cells   <word> 	0x00000001 )
        (property interrupt-map      <word>
            0x00008000 0x00000000 0x00000000 0x00000000 0x00001234 0x00000017
            0x00000800 0x00000000 0x00000000 0x00000000 0x00001234 0x00000018  )
        (property interrupt-map-mask <word>
            0x0000f800 0x00000000 0x00000000 0x00000000  )

        (property bus-range          <word>	0x00000000 0x00000000  )
        (property ranges             <word>
            0x01000000 0x00000000 0x00000000 0xfe000000 0x00000000 0x00800000 
            0x02000000 0x00000000 0x00000000 0xfd000000 0x00000000 0x01000000 
            0x02000000 0x00000000 0x80000000 0x80000000 0x00000000 0x7d000000  )
        (property bus-master-capable <word> 	0x00012000 )
        (property slot-names         <word>	0x00010000 0x4a313200  )
        (property clock-frequency    <word> 	0x01FCA055 )
        (property #size-cells        <word> 	0x00000002 )
        (property #address-cells     <word> 	0x00000003 )
        (property reg                <word>	0x80000000 0x7f000000  )
        (property used-by-rtas       <word>	)
        (property built-in           <word>	)
        (property compatible         <str>  	"grackle" )
        (property model              <str>  	"MOT,MPC106" )
        (property device_type        <str>  	"pci" )
        (property name               <str>  	"pci" )

    	#
	# ####################### MOL video ############################
	#
  	{
	    (name MacOnLinuxVideo )
	    (type display )
	    (property mol-irq <word> 0x17 )

	    (mol_phandle 0x2000 )
	    (property AAPL,boot-display <word> 0x2000 )

	    (property device_type  <str> 	"display" )
	    (property name <str> 	"MacOnLinuxVideo" )
	    (property model <str> "yonk" )

            (property vendor-id	<word>	0x00006666 )
            (property device-id	<word>	0x00006666 )
            (property revision-id	<word>	0x00001011 )
	    (property interrupts 	<word> 	0x00000001 )
	    (property min-grant 	<word> 	0x0 )
	    (property max-latency 	<word> 	0x0 )
            (property class-code	<word>	0x00030000 )
	    (property devsel-speed <word> 	0x0 )

	    #(property fcode-rom-offset <word> 0x0 )

	    (property power-consumption <word> 
		0x00000000 0x00000000 0x007270e0 0x007270e0
		0x00000000 0x00000000 0x007b98a0 0x007b98a0 )

            (property reg <word>
		0x00008000 0x00000000 0x00000000 0x00000000 0x00000000 
		0x02008010 0x00000000 0x00000000 0x00000000 0x01000000 )
	    (property assigned-addresses <word>
		0x82008010 0x00000000 0x81000000 0x00000000 0x01000000 )
        }
    }
}
