# -*- makefile -*-
##############################################################
# This makefile contains rules to build kernel sources
# and generate the kernel module
##############################################################

KHEADERS		= @KHEADERS@

if LINUX

MODVERSIONS		:= $(shell test -f $(KHEADERS)/linux/modversions.h && \
				echo "-DMODVERSIONS -include $(KHEADERS)/linux/modversions.h" )

A_CFLAGS		= @CFLAGS@ -Wall -msoft-float -fno-builtin $(MODVERSIONS)
A_INCLUDES		= -D__KERNEL__ -DMODULE -I$(top_srcdir)/src/kmod/include \
			  -I$(top_srcdir)/src/shared -I- -I$(KHEADERS)

###########################################################################
# Kernel module generation
###########################################################################

A_KERNEL_MODULE		= mol.o

$(A_KERNEL_MODULE):
	@$(RM) $@
	@$(LD) -r $(KMOD_OBJS) `cat Linux/objs` -o $@
	echo $(LD) -r $(KMOD_OBJS) `cat Linux/objs` -o $@
	@chmod +x checker.pl
	@./checker.pl $@ || (echo "checker.pl failed" ; rm $(KMOD) ; false)
	$(STRIP) -g $@
	$(INSTALL) -d $(top_srcdir)/mollib/modules/`./kuname`
	ln -f $(A_KERNEL_MODULE) $(top_srcdir)/mollib/modules/`./kuname`/

endif

all-local: $(KUNAME_DEP)
