/* 
 *   Creation Date: <2002/01/12 22:11:51 samuel>
 *   Time-stamp: <2002/09/05 01:35:57 samuel>
 *   
 *	<archinclude.h>
 *	
 *	
 *   
 *   Copyright (C) 2002 Samuel Rydh (samuel@ibrium.se)
 *   
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation
 *   
 */

#ifndef _H_ARCHINCLUDE
#define _H_ARCHINCLUDE

//#define PERF_MONITOR
//#define PERFORMANCE_INFO	     	/* collect performance statistics */
//#define PERFORMANCE_INFO_LIGHT	/* sample only the most important counters */

#ifdef __cplusplus
extern "C" {
#endif

#include "mol_config.h"
#ifdef __linux__
#include "compat.h"
#endif

#ifdef __cplusplus
}
#endif

#ifndef __ASSEMBLY__

/************************************************************************/
/*	Linux includes							*/
/************************************************************************/

#ifdef __linux__
#include <linux/kernel.h>
#if 0
//#include <linux/types.h>
//#include <linux/slab.h>
//#include <linux/vmalloc.h>
//#include <asm/unistd.h>
#endif
#endif /* __linux__ */


/************************************************************************/
/*	Darwin includes							*/
/************************************************************************/

#ifdef __darwin__
#ifdef __cplusplus
#include <sys/systm.h>
#include <IOKit/IOLib.h>
#else
#include <sys/param.h>
#include <sys/types.h>
#include <sys/systm.h>
#include <libkern/libkern.h>
#include <kern/task.h>
#include <kern/thread.h>
#include <stddef.h>
#include <IOKit/IOLib.h>
#endif
#define printk printf
#endif /* __darwin__ */

/* Typesafe min/max (stolen from kernel.h) */
#define min_mol(x,y) ({ \
        const typeof(x) _x = (x);       \
        const typeof(y) _y = (y);       \
        (void) (&_x == &_y);            \
        _x < _y ? _x : _y; })

#define max_mol(x,y) ({ \
        const typeof(x) _x = (x);       \
        const typeof(y) _y = (y);       \
        (void) (&_x == &_y);            \
        _x > _y ? _x : _y; })

#endif	 /* __ASSEMBLY__ */
#endif   /* _H_ARCHINCLUDE */
