/* 
 *   Creation Date: <97/06/16 18:02:12 samuel>
 *   Time-stamp: <2002/08/04 15:17:23 samuel>
 *   
 *	<misc.h>
 *	
 *	
 *   
 *   Copyright (C) 1997-2002 Samuel Rydh (samuel@ibrium.se)
 *   
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation
 *   
 */

#ifndef _H_MOD
#define _H_MOD

extern int 	g_num_sessions;			/* number of active sessions */

struct kernel_vars;

/* init.c */
extern int	common_init_module( void );
extern void	common_cleanup_module( void );
extern int	initialize_session( int sess_index, ulong session_magic );
extern void	destroy_session( int sess_index );
extern int	get_performance_info( kernel_vars_t *kv, int index, char *retbuf, 
				      int size, int *retval );
extern void	clear_performance_info( kernel_vars_t *kv );

/* Darwin/init.c */
#ifndef __linux__
extern	int	init_module( void );
extern	void	cleanup_module( void );
#endif

/* Linux/misc.c */
extern struct kernel_vars *alloc_kvar_pages( void );
extern void	free_kvar_pages( struct kernel_vars *kv );

/* Linux/init.c */
extern void	inc_mod_count( void );
extern void	dec_mod_count( void );

/* hook.c */
extern int	relocate_code( void );
extern void	relocation_cleanup( void );
extern int	write_hooks( void );
extern void	remove_hooks( void );

/************************************************************************/
/*	bit table manipulation						*/
/************************************************************************/

static inline void
set_bit_mol( int nr, char *addr )
{
	ulong mask = 1 << (nr & 0x1f);
	ulong *p = ((ulong*)addr) + (nr >> 5);
	*p |= mask;
}

static inline void 
clear_bit_mol( int nr, char *addr )
{
	ulong mask = 1 << (nr & 0x1f);
	ulong *p = ((ulong*)addr) + (nr >> 5);
	*p &= ~mask;
}


#endif

